module Main where

import Graphics.UI.GIO

main
  = start "SimpleMenu" "1.0" SDI [] $
    do w <- window [view =: sz 200 200]
       showWindow w

       bmpNew  <- readBitmap "res/new.bmp"  []
       bmpOpen <- readBitmap "res/open.bmp" []
       bmpSave <- readBitmap "res/save.bmp" []

       fm  <- menu [title =: "&File"] mainMenu
       menuitem [ title =: "&New"
                , accel =: KeyChar '\^N'
                , on command =: messageAlert "NEW"
                , icon =: Just bmpNew
                ] fm
       menuitem [title =: "&Open"
                , accel =: KeyChar '\^O'
                , on command =: messageAlert "OPEN"
                , icon =: Just bmpOpen
                ] fm
       menuitem [title =: "&Close"] fm       
       menuline fm
       menuitem [ title =: "&Save"
                , accel =: KeyChar '\^S'
                , on command =: messageAlert "SAVE"
                , icon =: Just bmpSave
                ] fm
       menuline fm
       menuitem [title =: "&Exit", on command =: halt] fm

       mColor <- menu [title =: "&Color"] mainMenu
       menucheck [title =: "&Transparent", accel =: KeyChar '\^T', on command =:: onToggleTransparent] mColor
       menuline mColor
       mRed   <- menuRadioItem [title =: "&Red",   on command =: messageAlert "RED COLOR"  ] mColor
       mGreen <- menuRadioItem [title =: "&Green", on command =: messageAlert "GREEN COLOR"] mColor
       mBlue  <- menuRadioItem [title =: "&Blue",  on command =: messageAlert "BLUE COLOR" ] mColor
       setMenuRadioGroup [mRed, mGreen, mBlue]
    where
       onToggleTransparent tgl = do
          chk <- get tgl checked
          messageAlert (if chk then "TRANSPARENT ON" else "TRANSPARENT OFF")

